package io.accumulatenetwork.sdk.generated.query;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: QueryType
// UnionValue: Synth

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("RequestSynth")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class RequestSynth implements Marshallable {
	public final QueryType type = QueryType.SYNTH;
	private Url source;
	private Url destination;
	private long sequenceNumber;
	private boolean anchor;

    //
	public Url getSource() {
	    return source;
	}
	public void setSource(final Url value) {
	    this.source = value;
	}

	public RequestSynth source(final Url value) {
	    setSource(value);
	    return this;
	}
	public RequestSynth source(final String value) {
	    setSource(Url.toAccURL(value));
	    return this;
	}
	public Url getDestination() {
	    return destination;
	}
	public void setDestination(final Url value) {
	    this.destination = value;
	}

	public RequestSynth destination(final Url value) {
	    setDestination(value);
	    return this;
	}
	public RequestSynth destination(final String value) {
	    setDestination(Url.toAccURL(value));
	    return this;
	}
	public long getSequenceNumber() {
	    return sequenceNumber;
	}
	public void setSequenceNumber(final long value) {
	    this.sequenceNumber = value;
	}

	public RequestSynth sequenceNumber(final long value) {
	    setSequenceNumber(value);
	    return this;
	}
	public boolean getAnchor() {
	    return anchor;
	}
	public void setAnchor(final boolean value) {
	    this.anchor = value;
	}

	public RequestSynth anchor(final boolean value) {
	    setAnchor(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.source == null)) {
            marshaller.writeUrl(2, this.source);
        }
        if (!(this.destination == null)) {
            marshaller.writeUrl(3, this.destination);
        }
        if (!(this.sequenceNumber == 0)) {
            marshaller.writeUint(4, this.sequenceNumber);
        }
        if (!(!this.anchor)) {
            marshaller.writeBool(5, this.anchor);
        }
        return marshaller.array();
    }
}
